#!/usr/bin/perl
#
#Program brokerstats.cgi:  harvest broker statistics
#Version 0.6 Hermann Straus, Madrid February 1998
#Send comments to hstraus@cipres.upm.es
#
#Kang-Jin Lee <lee@arco.met.fu-berlin.de> 30 January 2000
#Minor changes.

require "cgi_lib.pl";
&ReadParse;   # puts in @in the variables from the HTML page.

#######################################################################
# User configurable parameters
#######################################################################
$logprefix="/usr/local/harvest/brokers/";
$bargifurl="/~hstraus/blueblock.gif";
$brokerprefix="http://buho.cipres.upm.es/Harvest/brokers/";


################################
# Read variables from HTML page
################################
$broker=@in{'broker'};   #broker name

$maxdetail=@in{'maxdetail'}; #max detail in query list

$ano_ini=@in{'ano_ini'};   # initial year
$mes_ini=@in{'mes_ini'};   # initial month
$dia_ini=@in{'dia_ini'};   # initial day

$ano_fin=@in{'ano_fin'};   # same for final
$mes_fin=@in{'mes_fin'};
$dia_fin=@in{'dia_fin'};


#to make tests from the command line
#$broker="MAP-comparativa1";
#$maxdetail=2;
#$ano_ini=1997;
#$mes_ini=12;
#$dia_ini=26;

#$ano_fin=1998;
#$mes_fin="01";
#$dia_fin="12";

#$fechaini="19980120";
#$fechafin="19980120";



#######################################################################
# Definicion de variables
#######################################################################
$logfile=$logprefix.$broker.'/broker.out';
$brokerurl=$brokerprefix.$broker;

$fechaini=$ano_ini.$mes_ini.$dia_ini;  #initial date
$fechafin=$ano_fin.$mes_fin.$dia_fin;  #final date


%stat = (
         'totresult',      0, # number of results given
         'totqueries',	   0, # number of queries received
         'totcomplet',     0, # number of queries completed
         'resmax',	   0, # maximo de results results
         'errores',        0, # numero de errores
         'maxhour',        0, # number of queries in the 'top' hour
         'maxhourv',	   0, # 'top' hour
         'maxresgrp',	   1, # number of results in the 'top' result group
         'maxresgrpv',	   0, # 'top' result group

         'hr0',           '0', # accesses in hour 0
         'hr1',           '0', # accesses in hour 1
         'hr2',           '0', # accesses in hour 2
         'hr3',           '0', # accesses in hour 3
         'hr4',           '0', # accesses in hour 4
         'hr5',           '0', # accesses in hour 5
         'hr6',           '0', # accesses in hour 6
         'hr7',           '0', # accesses in hour 7
         'hr8',           '0', # accesses in hour 8
         'hr9',           '0', # accesses in hour 9
         'hr10',          '0', # accesses in hour 10
         'hr11',          '0', # accesses in hour 11
         'hr12',          '0', # accesses in hour 12
         'hr13',          '0', # accesses in hour 13
         'hr14',          '0', # accesses in hour 14
         'hr15',          '0', # accesses in hour 15
         'hr16',          '0', # accesses in hour 16
         'hr17',          '0', # accesses in hour 17
         'hr18',          '0', # accesses in hour 18
         'hr19',          '0', # accesses in hour 19
         'hr20',          '0', # accesses in hour 20
         'hr21',          '0', # accesses in hour 21
         'hr22',          '0', # accesses in hour 22
         'hr23',          '0', # accesses in hour 23

         'r0',		  '0', # results 0
         'r5',		  '0', # results 0-5
         'r10',		  '0', # results 6-10
         'r20',		  '0', # results 11-20
         'r50',		  '0', # results 21-50
         'rn',		  '0' # results 51-
        );


#######################################################################
# Main program
#######################################################################


#Print HTTP Header, and then the HTML.

print "Content-type: text/html\n\n";

print "<HTML>\n";
print "<HEAD>\n";
print "<TITLE>Broker Statistics</TITLE>\n";
print "</HEAD>\n";
print '<BODY BGCOLOR="#FFFFFF">',"\n";
&Calcula;
print "<HR><H1>Statistics for the Broker <EM>$broker</EM></H1><HR>\n";
print "<CENTER>\n";
print "From $dia_ini/$mes_ini/$ano_ini to $dia_fin/$mes_fin/$ano_fin <BR>\n";
print "The broker obtained <EM>$stats{'totresult'}</EM> results\n";
print "in <EM>$stats{totqueries}</EM> queries,";
print " completing <EM>$stats{'totcomplet'}</EM>. \n";
&GrafResults;
print "</CENTER>\n";
print '<TABLE border="0">',"\n";
print '<TR><TD>';
  &GrafHoras;
print "</TD>\n";
print "<TD>";
  &AnalyseStructure;
  &OtherData;
print "</TD></TR>\n";
print "</TABLE>\n";
print "<BR>\n";
print "<H3>The following is a detailed list of the queries:</h3>\n";
&Detailed;
&Message;
&Final;
print "</BODY>\n";
print "</HTML>\n";
exit;


##########################################################################
# Subroutines
###########################################################################

#Comprueba: comprueba que los datos sean correctos    (useless yet)
#####################################################################
sub Comprueba {
}


#error : da un mensaje de error  (useless yet)
############################################################################
sub error {
  print "Ocurri un error calculando las estadsticas.<BR>\n";
}

#Calcula : obtain the statistics
######################################################
sub Calcula {
open(A,$logfile);
 if(eof(A))
  { print "<H2>Sorry, $logfile couldn't be opened</H2>"; die;}

 while(<A>)

 {
 chop;
 @campos=split(' ',$_);

 # see if dates are in range
 $date=$campos[1];
 if ( ($date < $fechaini) || ($date > $fechafin) ) {next;}

 if ($_ =~ /Processing Query/)
 #  get the time of query from these lines
    {


      ## Necessary to use Eric Lease routines
      ($trash, $q) = split (/\#END /i,$_);
      push (@queries, "$q\n");


      $time=$campos[2];
      @timesplit=split(':',$time);
      $hour=$timesplit[0];
      $minutes=$timesplit[1];
      $seconds_i=($timesplit[2] + $minutes*60 + $hour*3600);
      $date_i=$date;


      for ($i=0;$i<24;$i++)
      {  if ($hour == $i)
         {
          $stats{'hr'.$i}++;
          if ($stats{'hr'.$i} > $stats{'maxhour'})
             {
               $stats{'maxhour'} = $stats{'hr'.$i};
               $stats{'maxhourv'} = $i;
             }
           break;
         }
      }

      #Here is the count of queries recieved
      $stats{'totqueries'}++;

    }

 elsif ($_ =~ /Query returned/)
 # get the number of results returned
    {
      $resultados=$campos[5];

      if ($resultados > $stats{'resmax'}) {$stats{'resmax'} = $resultados;}

      $stats{totresult}=$stats{totresult}+$resultados;
      if ($resultados==0)       { $lastr = (++$stats{r0})}
      elsif ($resultados <= 5)  { $lastr = (++$stats{r5});}
      elsif ($resultados <= 10) { $lastr = (++$stats{r10});}
      elsif ($resultados <= 20) { $lastr = (++$stats{r20});}
      elsif ($resultados <= 50) { $lastr = (++$stats{r50});}
      else                      { $lastr = (++$stats{rn});}

      if ($lastr > $stats{'maxresgrp'})
          {
             $stats{'maxresgrp'} = $lastr;
          }

      #Here is the count of completed queries
      $stats{'totcomplet'}++;

      # Here is computed the processing time

      # First, check if processed querytime

      if ($seconds_i != 0)
      {
        $time=$campos[2];
        @timesplit=split(':',$time);
        $seconds_f=($timesplit[2]+$timesplit[1]*60 + $timesplit[0]*3600);
        # Be careful with the midnight!
        # The time is calculated relative to the first day
        if ($date != $date_i) {$seconds_f = $seconds_f + 24*3600;}
        $seconds_taken=$seconds_f - $seconds_i;

        if ($time{$q} != 0)
        { $time{$q}=$seconds_taken + $time{$q};
          if ($maxtime{$q} < $seconds_taken ) { $maxtime{$q} = $seconds_taken;}
          if ($mintime{$q} > $seconds_taken ) { $mintime{$q} = $seconds_taken;}
        }
        else {
          $time{$q} = $seconds_taken;
          $maxtime{$q} = $seconds_taken;
          $mintime{$q} = $seconds_taken;
        }

        # now reset seconds_i to be able to check if the querytime is processed
        $seconds_i=0;
      }

    }
 elsif ($_ =~ /Inline query timeout/)
 # Time Out
    {
      $timeout++;
    }

 else {}#Other lines
 } #while
 close(A);
}



# Sub Graficos Horas : Hour graphs
###########################

sub GrafHoras {

print '<TABLE ALIGN="LEFT" BORDER=1>',"\n";
print '<TR bgcolor="0080ff"><TH COLSPAN=4><HR SIZE=5>Queries by hour<HR SIZE=5></TH></TR>',"\n";
print '<TR bgcolor="ffbf00"><TH>Hours </TH><TH>Number</TH><TH>% of total</TH><TH> </TH></TR>',"\n";

for ($i=0;$i<24;$i++)
{
 print "<TR><TH ALIGN=RIGHT><DT> $i:00 - ",$i+1,":00 </TH>\n";
 print "<TD ALIGN=MIDDLE>$stats{'hr'.$i} </TD>\n";
 print "<TD ALIGN=MIDDLE>";
 if ($stats{'totqueries'} > 0 )
  { printf("%.2f",($stats{'hr'.$i}/$stats{'totqueries'})*100); }
 else {print "0";}
 print ' %</TD><TD ALIGN=LEFT>';
 if ($stats{'hr'.$i} > 0 )
   {
    $ancho=$stats{'hr'.$i}*100/$stats{'maxhour'};
    print '<IMG SRC="',$bargifurl,'" ALT="';
       $j=0;
       while ($j<$ancho)
          { print "*";
            $j=$j+5}
    print '" HEIGHT=15 WIDTH=';
    print $ancho, " BORDER=1>";
   }
 print "</TD></TR>";
}
print "</TABLE>\n";
}

# Sub OtherData : Other data
##################################
sub OtherData {
print "<P>";
print "<UL>\n";
print "<LI> Number of queries received: <EM>$stats{'totqueries'}</EM>\n";
print "<LI> Number of completed queries: <EM>$stats{'totcomplet'}</EM>\n";
print "<LI> Number of timeouts: <EM>$timeout</EM>\n";
print "<LI> The maximum number of results obtained for a query was: <EM>$stats{resmax}</EM>\n";
print "<LI> The 'top' hour was <EM>", $stats{'maxhourv'},":00 - ",$stats{'maxhourv'}+1,":00 </EM>, where the broker received <EM>$stats{'maxhour'}</EM> queries\n";
print "<LI>The 'top' result group happened <EM>$stats{'maxresgrp'}</EM> times.\n";
print "</UL>\n";
}


# Sub Final
##################################
sub Final {
# get the month and year
($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
$mon = $mon + 1;
$mon = "0".$mon if ($mon <= 10);

$theDate = "$mon/$year";

$theDate = "$mday/$mon/$year";
print "<HR>\n\n";
print "$theDate<br>";
}


# Sub Message : additional message
# You may delete my name...  ;-)
##################################
sub Message {
print "<P>";
print 'Here you can access the <A href="',$brokerurl,'">Broker main page</A>.',"
\n";
print '<P><HR><EM>Written by <A href="http://www.cipres.upm.es/~hstraus/">Hermann Straus</A>.<BR><A href="http://www.cipres.upm.es/">CIPRES-UPM</A>.</EM>',"\n";
}

# Sub Graficos Resultados        #should be rewritten in a better way
#################################
sub GrafResults {
print "<TABLE BORDER=1 WIDTH=100%>\n";
print '<TR bgcolor="0080ff"><TH COLSPAN=4><HR SIZE=5>Results statistics<HR SIZE=5></TH></TR>',"\n";
print '<TR bgcolor="ffbf00"><TH>Results found</TH><TH>Number</TH><TH>% of total</TH><TH> </TH></TR>',"\n";

print "<TR><TH ALIGN=RIGHT><DT>Not found </TH>\n";
print "<TD ALIGN=RIGHT>$stats{r0} </TD>\n";
print "<TD ALIGN=RIGHT>";
if ( $stats{'totcomplet'} > 0)
 {
    printf("%.2f",($stats{r0}/$stats{'totcomplet'})*100);
 }
else {print "0";}
print ' %</TD><TD ALIGN=LEFT><IMG SRC="',$bargifurl,'" ALT="';


if ($stats{'r0'} > 0 )
   {
    $ancho=$stats{'r0'}*100/$stats{'maxresgrp'};
    print '<IMG SRC="',$bargifurl,'" ALT="';
       $j=0;
       while ($j<$ancho)
          { print "*";
            $j=$j+5}
    print '" HEIGHT=15 WIDTH=';
    print $ancho, " BORDER=1>";
   }
else {print '">';}


print "</TD></TR>";

print "<TR><TH ALIGN=RIGHT><DT> 1 - 5 </TH>\n";
print "<TD ALIGN=RIGHT>$stats{r5} </TD>\n";
print "<TD ALIGN=RIGHT>";
if ( $stats{'totcomplet'} > 0)
 {
    printf("%.2f",($stats{r5}/$stats{'totcomplet'})*100);
 }
else {print "0";}
print ' %</TD><TD ALIGN=LEFT><IMG SRC="',$bargifurl,'" ALT="';

if ($stats{'r5'} > 0 )
   {
    $ancho=$stats{'r5'}*100/$stats{'maxresgrp'};
    print '<IMG SRC="',$bargifurl,'" ALT="';
       $j=0;
       while ($j<$ancho)
          { print "*";
            $j=$j+5}
    print '" HEIGHT=15 WIDTH=';
    print $ancho, " BORDER=1>";
   }
else {print '">';}

print "</TD></TR>";


print "<TR><TH ALIGN=RIGHT><DT> 6 - 10</TH>\n";
print "<TD ALIGN=RIGHT>$stats{r10} </TD>\n";
print "<TD ALIGN=RIGHT>";
if ( $stats{'totcomplet'} > 0)
 {
    printf("%.2f",($stats{r10}/$stats{'totcomplet'})*100);
 }
else {print "0";}
print ' %</TD><TD ALIGN=LEFT><IMG SRC="',$bargifurl,'" ALT="';


if ($stats{'r10'} > 0 )
   {
    $ancho=$stats{'r10'}*100/$stats{'maxresgrp'};
    print '<IMG SRC="',$bargifurl,'" ALT="';
       $j=0;
       while ($j<$ancho)
          { print "*";
            $j=$j+5}
    print '" HEIGHT=15 WIDTH=';
    print $ancho, " BORDER=1>";
   }
else {print '">';}

print "</TD></TR>";


print "<TR><TH ALIGN=RIGHT><DT> 11 - 20</TH>\n";
print "<TD ALIGN=RIGHT>$stats{r20} </TD>\n";
print "<TD ALIGN=RIGHT>";
if ( $stats{'totcomplet'} > 0)
 {
    printf("%.2f",($stats{r20}/$stats{'totcomplet'})*100);
 }
else {print "0";}
print ' %</TD><TD ALIGN=LEFT><IMG SRC="',$bargifurl,'" ALT="';

if ($stats{'r20'} > 0 )
   {
    $ancho=$stats{'r20'}*100/$stats{'maxresgrp'};
    print '<IMG SRC="',$bargifurl,'" ALT="';
       $j=0;
       while ($j<$ancho)
          { print "*";
            $j=$j+5}
    print '" HEIGHT=15 WIDTH=';
    print $ancho, " BORDER=1>";
   }
else {print '">';}

print "</TD></TR>";


print "<TR><TH ALIGN=RIGHT><DT> 21 - 50</TH>\n";
print "<TD ALIGN=RIGHT>$stats{r50} </TD>\n";
print "<TD ALIGN=RIGHT>";
if ( $stats{'totcomplet'} > 0)
 {
    printf("%.2f",($stats{r50}/$stats{'totcomplet'})*100);
 }
else {print "0";}
print ' %</TD><TD ALIGN=LEFT><IMG SRC="',$bargifurl,'" ALT="';

if ($stats{'r50'} > 0 )
   {
    $ancho=$stats{'r50'}*100/$stats{'maxresgrp'};
    print '<IMG SRC="',$bargifurl,'" ALT="';
       $j=0;
       while ($j<$ancho)
          { print "*";
            $j=$j+5}
    print '" HEIGHT=15 WIDTH=';
    print $ancho, " BORDER=1>";
   }
else {print '">';}

print "</TD></TR>";


print "<TR><TH ALIGN=RIGHT><DT>More than 50</TH>\n";
print "<TD ALIGN=RIGHT>$stats{rn} </TD>\n";
print "<TD ALIGN=RIGHT>";
if ( $stats{'totcomplet'} > 0)
 {
    printf("%.2f",($stats{rn}/$stats{'totcomplet'})*100);
 }
else {print "0";}
print ' %</TD><TD ALIGN=LEFT><IMG SRC="',$bargifurl,'" ALT="';

if ($stats{'rn'} > 0 )
   {
    $ancho=$stats{'rn'}*100/$stats{'maxresgrp'};
    print '<IMG SRC="',$bargifurl,'" ALT="';
       $j=0;
       while ($j<$ancho)
          { print "*";
            $j=$j+5}
    print '" HEIGHT=15 WIDTH=';
    print $ancho, " BORDER=1>";
   }
else {print '">';}

print "</TD></TR>";


print "</TABLE>\n";

}


############
## Analyse Structure
############
# Eric Lease Morgan
# http://www.lib.ncsu.edu/staff/morgan/
# 12/31/96 - first cut

#######
# - Original de Eric Lease Morgan
# - Modificacion en la presentacion por Javier Massa
# - Capacidad de especificar numero minimo de apariciones, integracion
#   en cgi-bin y correcion del bug del numero total de busquedas
#   por Hermann Straus
#

sub AnalyseStructure {
$phrase = 0;
$and = 0;
$or = 0;
$truncation = 0;
$compound = 0;
$field = 0;
$singleTerm = 0;

# analyse the queries in terms of their structure
for (@queries) {

   if (/"/)       { $phrase++; }
   if (/ and /i)  { $and++; }
   if (/ or /i)   { $or++; }
   if (/\*/)      { $truncation++; }
   if (/\(/)      { $compound++; }
   if (/: /)      { $field++; }
   if (!/ /)      { $singleTerm++; }
   }



print " <p><table border=0 bgcolor=\"000000\" cellpadding=1 cellspacing=0><tr><td>
<table border=0 bgcolor=\"eeeeee\" cellpadding=3 cellspacing=0>
<tr bgcolor=\"#ffcc00\">
        <td>
                <font face=\"helvetica,times\">Query type</font>
        </td>
        <td>
                <font face=\"helvetica,times\">Number</font>
        </td>
</tr>
<tr></tr>
<tr align=right>
        <td align=right valign=top>
                <font face=\"helvetica,times\">Single terms</font>
        </td>
        <td valign=top>
                <font face=\"helvetica,times\">$singleTerm</font>
        </td>
</tr>
<tr align=right>
        <td align=right valign=top>
                <font face=\"helvetica,times\">Phrases</font>
        </td>
        <td valign=top>
                <font face=\"helvetica,times\">$phrase</font>
        </td>
</tr>
<tr align=right>
        <td align=right valign=top>
                <font face=\"helvetica,times\">logic AND</font>
        </td>
        <td valign=top>
                <font face=\"helvetica,times\">$and</font>
        </td>
</tr>
<tr align=right>
        <td align=right valign=top>
                <font face=\"helvetica,times\">logic OR</font>
        </td>
        <td valign=top>
                <font face=\"helvetica,times\">$or</font>
        </td>
</tr>
<tr align=right>
        <td align=right valign=top>
                <font face=\"helvetica,times\">Compound</font>
        </td>
        <td valign=top>
                <font face=\"helvetica,times\">$compound</font>
        </td>
</tr>
<tr align=right>
        <td align=right valign=top>
                <font face=\"helvetica,times\">by field</font>
        </td>
        <td valign=top>
                <font face=\"helvetica,times\">$field</font>
        </td>
</tr>
<tr></tr>
<tr align=right>
        <td align=right valign=top>
                <font face=\"helvetica,times\">Total queries</font>
        </td>
        <td valign=top>
                <font face=\"helvetica,times\">",$#queries+1,"</font>
        </td>
</tr>
</table>
</td></tr></table>
<p>
";
}


# Detailed
########################################################################
sub Detailed {

# sort the queries, count each one, tabulate the results, and sort again
@queries = sort @queries;
for (@queries) { $c{$_}++; }

#for (sort keys %c) { push (@cQueries, sprintf "%4d\t %s", $c{$_}, $_ ); }
#
# Esto lo cambio para poder especificar un numero minimo de apariciones
# ya que la lista de busquedas que solo aparecen una vez puede no ser
# un dato significativo


for (sort keys %c)
  {
      $clave= $_;
      chomp $clave;

      if ($c{$_} >= $maxdetail) {push (@cQueries, sprintf "%4d\t %3d\t %3d\t %3d\t %s", $c{$_},$time{$clave}/$c{$_}, $maxtime{$clave}, $mintime{$clave}, $_);}


  }

@cQueries = sort numerically @cQueries;

# print tablulated results
print "<pre>\n";
print "\n\n";
print "        Proc. time (seconds)                       \n";
print "Number\t Av.\t Max.\t Min.\t Query\n";
print "-------------------------------------------------\n";
print @cQueries;
print "\n";

print "</pre>\n";


# a subroutine for sorting in reverse numeric order
sub numerically { $b <=> $a; }

} #sub Detailed





#######################
#FORMATO DE Broker.out
#######################
# broker: 19980116 11:14:25: Processing Query 33: #USER #opaque #desc #index error on #index maxresult 1500 #index maxfiles 1000 #index maxlines 5 #index case insensitive #index matchword #END trdt
# broker: 19980116 11:14:25: Query returned 5 objects.


