/*************************************************************************************************
 * CuriaException.class
 * Exception container of Curia
 *                                                       Copyright(c) 2000-2003 Mikio Hirabayashi
 *************************************************************************************************/


package qdbm;


/**
 * Exception container of Curia.
 */
public class CuriaException extends DBMException {
  //----------------------------------------------------------------
  // instance fields
  //----------------------------------------------------------------
  /** error code */
  public final int ecode;
  //----------------------------------------------------------------
  // public or protected methods
  //----------------------------------------------------------------
  /**
   * Set the error code with `Curia.EMISC'.
   */
  public CuriaException(){
    this(Curia.EMISC);
  }
  /**
   * Set the error code.
   * @param ecode an error code.
   */
  public CuriaException(int ecode){
    super(Curia.errmsg(ecode));
    this.ecode = ecode;
  }
}



/* END OF FILE */
