/*************************************************************************************************
 * DepotException.class
 * Exception container of Depot
 *                                                       Copyright(c) 2000-2003 Mikio Hirabayashi
 *************************************************************************************************/


package qdbm;


/**
 * Exception container of Depot.
 */
public class DepotException extends DBMException {
  //----------------------------------------------------------------
  // instance fields
  //----------------------------------------------------------------
  /** error code */
  public final int ecode;
  //----------------------------------------------------------------
  // public or protected methods
  //----------------------------------------------------------------
  /**
   * Set the error code with `Depot.EMISC'.
   */
  public DepotException(){
    this(Depot.EMISC);
  }
  /**
   * Set the error code.
   * @param ecode an error code.
   */
  public DepotException(int ecode){
    super(Depot.errmsg(ecode));
    this.ecode = ecode;
  }
}



/* END OF FILE */
